Attribute VB_Name = "ModFileOp"
Option Explicit

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function BringWindowToTop Lib "user32" (ByVal hwnd As Long) As Long

Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function SHFileExists Lib "shell32" Alias "#45" (ByVal szPath As String) As Long
Private Declare Function PathFileExists Lib "shlwapi.dll" Alias "PathFileExistsA" (ByVal pszPath As String) As Long
Private Declare Function PathIsDirectory Lib "shlwapi.dll" Alias "PathIsDirectoryA" (ByVal pszPath As String) As Long
Public Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" (ByVal lpFileName As String) As Long
Private Const MAX_COMPUTERNAME_LENGTH As Long = 31
Private Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long

Private Declare Function ShellAbout Lib "shell32.dll" Alias "ShellAboutA" (ByVal hwnd As Long, ByVal szApp As String, ByVal szOtherStuff As String, ByVal hIcon As Long) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function GetCurrentDirectory Lib "kernel32" Alias "GetCurrentDirectoryA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

Public Enum SpFolder
    SP_DESKTOP = &H0
    SP_PROGRAMS = &H2
    SP_CONTROLS = &H3
    SP_PRINTERS = &H4
    SP_PERSONAL = &H5
    SP_FAVORITES = &H6
    SP_STARTUP = &H7
    SP_RECENT = &H8
    SP_SENDTO = &H9
    SP_BITBUCKET = &HA
    SP_STARTMENU = &HB
    SP_DESKTOPDIRECTORY = &H10
    SP_DRIVES = &H11
    SP_NETWORK = &H12
    SP_NETHOOD = &H13
    SP_FONTS = &H14
    SP_TEMPLATES = &H15
End Enum

Const MAX_PATH = 260

Private Type SHITEMID
    cb As Long
    abID As Byte
End Type

Private Type ITEMIDLIST
    mkid As SHITEMID
End Type
Public Function GetCurrentUserName() As String
    
    Dim strUserName As String
    
    strUserName = String(100, Chr$(0))
    GetUserName strUserName, 100
    strUserName = Left$(strUserName, InStr(strUserName, Chr$(0)) - 1)
    GetCurrentUserName = strUserName
    
End Function
Public Function GetAppPath() As String

    GetAppPath = App.path
    If Right(GetAppPath, 1) <> "\" Then GetAppPath = GetAppPath & "\"
    
End Function
Public Function GetExePath() As String

    Dim path As String

    path = GetAppPath
    GetExePath = path & App.EXEName & ".exe"

End Function

Public Function GetPCName() As String

    Dim dwLen As Long
    Dim strString As String
    
    dwLen = MAX_COMPUTERNAME_LENGTH + 1
    strString = String(dwLen, "X")
    GetComputerName strString, dwLen
    GetPCName = Left(strString, dwLen)

End Function

Public Function GetSpecialfolder(CSIDL As SpFolder) As String
    
    Dim r As Long
    Dim IDL As ITEMIDLIST
    Dim path As String
    r = SHGetSpecialFolderLocation(100, CSIDL, IDL)
    
    If r = 0 Then
        path = Space$(512)
        r = SHGetPathFromIDList(ByVal IDL.mkid.cb, ByVal path$)
        GetSpecialfolder = Left$(path, InStr(path, Chr$(0)) - 1)
        Exit Function
    End If
    
    GetSpecialfolder = ""
    
End Function


Public Function GetSysDir() As String

    Dim sSave As String, ret As Long
    
    sSave = Space(255)
    ret = GetSystemDirectory(sSave, 255)
    GetSysDir = Left$(sSave, ret)

End Function

Public Function GetWinDir() As String

    Dim sSave As String, ret As Long
    
    sSave = Space(255)
    ret = GetWindowsDirectory(sSave, 255)
    GetWinDir = Left$(sSave, ret)

End Function

Public Function GetSysDrive() As String

    Dim WinDir As String

    WinDir = GetWinDir
    GetSysDrive = Left(WinDir, 3)

End Function
Public Function FileExist(ByVal File As String) As Boolean
    
    FileExist = CBool(PathFileExists(File))
    
End Function

Public Function IsDir(ByVal File As String) As Boolean
    
    IsDir = CBool(PathIsDirectory(File))
    
End Function

Public Sub ExtrFile(ByVal ResNumber As Integer, ByVal ResName As String, ByVal FileName As String)

Dim ByteArray() As Byte
Dim i As Long
Dim ByteCount As Long

    ByteArray = LoadResData(ResNumber, ResName)

    Open FileName For Binary As #1

        ByteCount = UBound(ByteArray)

        For i = 0 To ByteCount
            Put #1, , ByteArray(i)
        Next i
        
        
    Close #1
    
End Sub


